
# Pack info
execute as @a[scores={pack_info=1..}] at @s run function pack:info
execute as @a[scores={language_menu=1..}] at @s run function pack:info

# Delete pack
execute as @a[scores={delete_pack=1..}] run function pack:challenges/reset/all with storage challenge:menu
execute as @a[scores={delete_pack=1..}] run scoreboard players set @s delete_pack 0

# Reset challenges
execute as @a[scores={reset_challenges=1..}] unless score @s page = @s page run scoreboard players set @s page 1
execute as @a[scores={reset_challenges=1..}] store result storage challenge:menu page byte 1 run scoreboard players get @s page
execute as @a[scores={reset_challenges=1..}] run function pack:challenges/reset/all with storage challenge:menu

# Change of settings
execute as @a[predicate=pack:changed_challenge] store result storage challenge:menu page byte 1 run scoreboard players get @s page
execute as @a[predicate=pack:changed_challenge] run function pack:challenges/show_menu_macro with storage challenge:menu

# Show menu
execute as @a[scores={challenge_settings=1..}] at @s run function pack:challenges/show_menu
execute as @a[scores={language_menu=-1}] at @s run function pack:language_menu

# Challenge settings
scoreboard players enable @a pack_info

# RTP - Radnom teleport
execute as @a[scores={rtp_menu=1..}] run function pack:rtp/rtp_menu
execute as @a[scores={rtp_reset=1..}] run function pack:rtp/rtp_menu
execute as @a[scores={rtp_player_distance=0..}] run function pack:rtp/rtp_menu
execute as @a[scores={rtp_max_distance=1..}] run function pack:rtp/rtp_menu
execute as @a[scores={rtp_self=1..}] run function pack:rtp/rtp_self with storage challenge:rtp distance
execute as @a[scores={rtp_all=1..}] run function pack:rtp/rtp_all with storage challenge:rtp distance

# CHALLENGES

    # xphealth
    execute if score .xphealth challenge_settings matches 2..3 as @a if score @s xp_level matches 0 run xp set @s 0 points
    execute if score .xphealth challenge_settings matches 2..3 as @a if score @s xp_level matches 0 run xp set @s 1 levels
    execute if score .xphealth challenge_settings matches 2..3 as @a store result score @s xp_level run xp query @s levels
    execute if score .xphealth challenge_settings matches 2..3 as @a store result score @s max_health run attribute @s generic.max_health base get
    execute if score .xphealth challenge_settings matches 2..3 as @a[scores={health=20}] if score @s xp_level matches 1 run function pack:challenges/xphealth/transfer
    execute if score .xphealth challenge_settings matches 2..3 as @a[scores={xp_level=1..}] unless score @s xp_level = @s max_health run function pack:challenges/xphealth/transfer
    execute if score .xphealth challenge_settings matches 3 as @a[scores={damage_taken=1..}] run function pack:challenges/xphealth/transfer

    # No sounds
    execute if score .no_sounds challenge_settings matches 2 run stopsound @a

    # Random knockback
    execute if score .random_knockback challenge_settings matches 2 as @e[type=!#pack:no_health,predicate=pack:hurted] run function pack:challenges/random_knockback/apply_motion
    execute if score .random_knockback challenge_settings matches 3 as @e[type=!#pack:no_health,predicate=pack:hurted] at @s run function pack:challenges/random_knockback/motion_toward_player

    # No jump
    execute if score .no_jump challenge_settings matches 1 as @a[predicate=pack:active_no_jump] run attribute @s generic.jump_strength modifier remove 0-0-0-0-0
	execute if score .no_jump challenge_settings matches 1..2 as @a[predicate=pack:active_strong_gravity] run attribute @s generic.gravity modifier remove 0-0-0-0-0
	execute if score .no_jump challenge_settings matches 2..3 as @a[predicate=!pack:active_no_jump] run attribute @s generic.jump_strength modifier add 0-0-0-0-0 no_jump -10 add_value
	execute if score .no_jump challenge_settings matches 3 as @a[predicate=!pack:active_strong_gravity] run attribute @s generic.gravity modifier add 0-0-0-0-0 strong_gravity 10 add_value

    # Random projectiles
    execute if score .random_projectiles challenge_settings matches 2 as @e[tag=!added,type=#impact_projectiles] at @s run function pack:challenges/random_projectiles/spawn
    execute if score .random_projectiles challenge_settings matches 2 as @e[tag=!added,type=shulker_bullet] at @s run function pack:challenges/random_projectiles/spawn

    # No crafting
    execute if score .no_crafting challenge_settings matches 2..3 as @a[advancements={minecraft:recipes/root=false}] run function pack:challenges/no_crafting/prepare

    # Only hotbar
    execute if score .only_hotbar challenge_settings matches 2 as @a[nbt={SelectedItem:{components:{"minecraft:custom_data":{lock:1}}}}] run item replace entity @s weapon.mainhand with air
	execute if score .only_hotbar challenge_settings matches 2..3 as @a[nbt={Inventory:[{Slot:-106b,components:{"minecraft:custom_data":{lock:1}}}]}] run item replace entity @s weapon.offhand with air
    execute if score .only_hotbar challenge_settings matches 2..3 as @a[scores={droped_lock=1..}] run kill @e[type=item,nbt={Item: {components: {"minecraft:custom_data": {lock:1}}}}]
	execute if score .only_hotbar challenge_settings matches 3 as @a[nbt={Inventory:[{Slot:0b,components:{"minecraft:custom_data":{lock:1}}}]}] run item replace entity @s weapon.mainhand with air
    scoreboard players reset @a[scores={droped_lock=1..}] droped_lock

    # Half size
	execute if score .half_size challenge_settings matches 1 as @a[predicate=pack:active_shrink_half_size] run function pack:challenges/half_size/change
	execute if score .half_size challenge_settings matches 1 as @a[predicate=pack:active_grow_half_size] run function pack:challenges/half_size/change
    execute if score .half_size challenge_settings matches 2 as @a[predicate=!pack:active_shrink_half_size] run function pack:challenges/half_size/change
    execute if score .half_size challenge_settings matches 3 as @a[predicate=!pack:active_grow_half_size] run function pack:challenges/half_size/change
	
	# No breaking
    execute if score .no_breaking challenge_settings matches 1 as @a[predicate=pack:active_no_breaking] run attribute @s player.block_break_speed modifier remove 2-2-2-2-2
	execute if score .no_breaking challenge_settings matches 2 as @a[predicate=!pack:active_no_breaking] run attribute @s player.block_break_speed modifier add 2-2-2-2-2 no_breaking -10 add_value
	
# Reset scoreboards
scoreboard players reset @a[scores={damage_taken=1..}] damage_taken
